# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ixblue_ins_msgs/Ins.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class Ins(genpy.Message):
  _md5sum = "d2db935e6e2c0ed5052a0b632ca4747b"
  _type = "ixblue_ins_msgs/Ins"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """Header header # Standard ROS message header

int8 ALT_REF_GEOID=0
int8 ALT_REF_ELLIPSOID=1

# Position
float64     latitude     # In degrees, positive north, [-90,90]
float64     longitude    # In degrees, increasgin toward east, [0,360]
int8        altitude_ref # 0: Geoid / 1: Ellipsoid, see constant above.
float32     altitude     # In meters, positive up

# Position Deviation
float64[9] position_covariance # In square meters, ENU in row-major order
                                # Null matrix if unknown

# Attitude
float32 heading # In degrees, [0,360]
float32 roll    # In degrees, positive port up, [-180,180]
float32 pitch   # In degrees, positive bow down, [-90,90]

# Attitude Deviation
float64[9] attitude_covariance # In rad2/sec2
                               # Null matrix if unknown

# Speed Vessel Frame
geometry_msgs/Vector3 speed_vessel_frame # In m/s, x: forward, y: left, z: up

# Speed Vessel Frame Deviation
float64[9] speed_vessel_frame_covariance # In m2/s4, ENU in row-major order
                                         # Null matrix if unknown

# Status
# TODO...

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  # Pseudo-constants
  ALT_REF_GEOID = 0
  ALT_REF_ELLIPSOID = 1

  __slots__ = ['header','latitude','longitude','altitude_ref','altitude','position_covariance','heading','roll','pitch','attitude_covariance','speed_vessel_frame','speed_vessel_frame_covariance']
  _slot_types = ['std_msgs/Header','float64','float64','int8','float32','float64[9]','float32','float32','float32','float64[9]','geometry_msgs/Vector3','float64[9]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,latitude,longitude,altitude_ref,altitude,position_covariance,heading,roll,pitch,attitude_covariance,speed_vessel_frame,speed_vessel_frame_covariance

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Ins, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.latitude is None:
        self.latitude = 0.
      if self.longitude is None:
        self.longitude = 0.
      if self.altitude_ref is None:
        self.altitude_ref = 0
      if self.altitude is None:
        self.altitude = 0.
      if self.position_covariance is None:
        self.position_covariance = [0.] * 9
      if self.heading is None:
        self.heading = 0.
      if self.roll is None:
        self.roll = 0.
      if self.pitch is None:
        self.pitch = 0.
      if self.attitude_covariance is None:
        self.attitude_covariance = [0.] * 9
      if self.speed_vessel_frame is None:
        self.speed_vessel_frame = geometry_msgs.msg.Vector3()
      if self.speed_vessel_frame_covariance is None:
        self.speed_vessel_frame_covariance = [0.] * 9
    else:
      self.header = std_msgs.msg.Header()
      self.latitude = 0.
      self.longitude = 0.
      self.altitude_ref = 0
      self.altitude = 0.
      self.position_covariance = [0.] * 9
      self.heading = 0.
      self.roll = 0.
      self.pitch = 0.
      self.attitude_covariance = [0.] * 9
      self.speed_vessel_frame = geometry_msgs.msg.Vector3()
      self.speed_vessel_frame_covariance = [0.] * 9

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2dbf().pack(_x.latitude, _x.longitude, _x.altitude_ref, _x.altitude))
      buff.write(_get_struct_9d().pack(*self.position_covariance))
      _x = self
      buff.write(_get_struct_3f().pack(_x.heading, _x.roll, _x.pitch))
      buff.write(_get_struct_9d().pack(*self.attitude_covariance))
      _x = self
      buff.write(_get_struct_3d().pack(_x.speed_vessel_frame.x, _x.speed_vessel_frame.y, _x.speed_vessel_frame.z))
      buff.write(_get_struct_9d().pack(*self.speed_vessel_frame_covariance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.speed_vessel_frame is None:
        self.speed_vessel_frame = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 21
      (_x.latitude, _x.longitude, _x.altitude_ref, _x.altitude,) = _get_struct_2dbf().unpack(str[start:end])
      start = end
      end += 72
      self.position_covariance = _get_struct_9d().unpack(str[start:end])
      _x = self
      start = end
      end += 12
      (_x.heading, _x.roll, _x.pitch,) = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 72
      self.attitude_covariance = _get_struct_9d().unpack(str[start:end])
      _x = self
      start = end
      end += 24
      (_x.speed_vessel_frame.x, _x.speed_vessel_frame.y, _x.speed_vessel_frame.z,) = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 72
      self.speed_vessel_frame_covariance = _get_struct_9d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2dbf().pack(_x.latitude, _x.longitude, _x.altitude_ref, _x.altitude))
      buff.write(self.position_covariance.tostring())
      _x = self
      buff.write(_get_struct_3f().pack(_x.heading, _x.roll, _x.pitch))
      buff.write(self.attitude_covariance.tostring())
      _x = self
      buff.write(_get_struct_3d().pack(_x.speed_vessel_frame.x, _x.speed_vessel_frame.y, _x.speed_vessel_frame.z))
      buff.write(self.speed_vessel_frame_covariance.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.speed_vessel_frame is None:
        self.speed_vessel_frame = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 21
      (_x.latitude, _x.longitude, _x.altitude_ref, _x.altitude,) = _get_struct_2dbf().unpack(str[start:end])
      start = end
      end += 72
      self.position_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      _x = self
      start = end
      end += 12
      (_x.heading, _x.roll, _x.pitch,) = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 72
      self.attitude_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      _x = self
      start = end
      end += 24
      (_x.speed_vessel_frame.x, _x.speed_vessel_frame.y, _x.speed_vessel_frame.z,) = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 72
      self.speed_vessel_frame_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2dbf = None
def _get_struct_2dbf():
    global _struct_2dbf
    if _struct_2dbf is None:
        _struct_2dbf = struct.Struct("<2dbf")
    return _struct_2dbf
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_3f = None
def _get_struct_3f():
    global _struct_3f
    if _struct_3f is None:
        _struct_3f = struct.Struct("<3f")
    return _struct_3f
_struct_9d = None
def _get_struct_9d():
    global _struct_9d
    if _struct_9d is None:
        _struct_9d = struct.Struct("<9d")
    return _struct_9d
